/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the TemplateRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplateRequest{}

// TemplateRequest struct for TemplateRequest
type TemplateRequest struct {
	Name string `json:"name"`
	ChannelId string `json:"channel_id"`
	OrganizationId string `json:"organization_id"`
	Type string `json:"type"`
	FileId string `json:"file_id"`
	Fields []map[string]interface{} `json:"fields,omitempty"`
	Mapping map[string]interface{} `json:"mapping,omitempty"`
}

// NewTemplateRequest instantiates a new TemplateRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplateRequest(name string, channelId string, organizationId string, type_ string, fileId string) *TemplateRequest {
	this := TemplateRequest{}
	this.Name = name
	this.ChannelId = channelId
	this.OrganizationId = organizationId
	this.Type = type_
	this.FileId = fileId
	return &this
}

// NewTemplateRequestWithDefaults instantiates a new TemplateRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplateRequestWithDefaults() *TemplateRequest {
	this := TemplateRequest{}
	return &this
}

// GetName returns the Name field value
func (o *TemplateRequest) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *TemplateRequest) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *TemplateRequest) SetName(v string) {
	o.Name = v
}

// GetChannelId returns the ChannelId field value
func (o *TemplateRequest) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *TemplateRequest) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *TemplateRequest) SetChannelId(v string) {
	o.ChannelId = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *TemplateRequest) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *TemplateRequest) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *TemplateRequest) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetType returns the Type field value
func (o *TemplateRequest) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *TemplateRequest) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *TemplateRequest) SetType(v string) {
	o.Type = v
}

// GetFileId returns the FileId field value
func (o *TemplateRequest) GetFileId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.FileId
}

// GetFileIdOk returns a tuple with the FileId field value
// and a boolean to check if the value has been set.
func (o *TemplateRequest) GetFileIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.FileId, true
}

// SetFileId sets field value
func (o *TemplateRequest) SetFileId(v string) {
	o.FileId = v
}

// GetFields returns the Fields field value if set, zero value otherwise.
func (o *TemplateRequest) GetFields() []map[string]interface{} {
	if o == nil || IsNil(o.Fields) {
		var ret []map[string]interface{}
		return ret
	}
	return o.Fields
}

// GetFieldsOk returns a tuple with the Fields field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateRequest) GetFieldsOk() ([]map[string]interface{}, bool) {
	if o == nil || IsNil(o.Fields) {
		return nil, false
	}
	return o.Fields, true
}

// HasFields returns a boolean if a field has been set.
func (o *TemplateRequest) HasFields() bool {
	if o != nil && !IsNil(o.Fields) {
		return true
	}

	return false
}

// SetFields gets a reference to the given []map[string]interface{} and assigns it to the Fields field.
func (o *TemplateRequest) SetFields(v []map[string]interface{}) {
	o.Fields = v
}

// GetMapping returns the Mapping field value if set, zero value otherwise.
func (o *TemplateRequest) GetMapping() map[string]interface{} {
	if o == nil || IsNil(o.Mapping) {
		var ret map[string]interface{}
		return ret
	}
	return o.Mapping
}

// GetMappingOk returns a tuple with the Mapping field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateRequest) GetMappingOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Mapping) {
		return map[string]interface{}{}, false
	}
	return o.Mapping, true
}

// HasMapping returns a boolean if a field has been set.
func (o *TemplateRequest) HasMapping() bool {
	if o != nil && !IsNil(o.Mapping) {
		return true
	}

	return false
}

// SetMapping gets a reference to the given map[string]interface{} and assigns it to the Mapping field.
func (o *TemplateRequest) SetMapping(v map[string]interface{}) {
	o.Mapping = v
}

func (o TemplateRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplateRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["type"] = o.Type
	toSerialize["file_id"] = o.FileId
	if !IsNil(o.Fields) {
		toSerialize["fields"] = o.Fields
	}
	if !IsNil(o.Mapping) {
		toSerialize["mapping"] = o.Mapping
	}
	return toSerialize, nil
}

type NullableTemplateRequest struct {
	value *TemplateRequest
	isSet bool
}

func (v NullableTemplateRequest) Get() *TemplateRequest {
	return v.value
}

func (v *NullableTemplateRequest) Set(val *TemplateRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateRequest(val *TemplateRequest) *NullableTemplateRequest {
	return &NullableTemplateRequest{value: val, isSet: true}
}

func (v NullableTemplateRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


